<template>
  <v-dialog
    v-model="dialog"
    scrollable
    attach="#app"
    v-bind="$attrs"
    @click:outside="close"
  >
    <v-card>
      <v-card-title>
        <span class="text-h5">{{ $t(i18n) }}</span>
      </v-card-title>

      <v-card-text>
        <v-form ref="form" v-model="valid" lazy-validation>
          <slot />
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer />
        <v-btn color="error" text @click="close">
          {{ $t("form.cancel") }}
        </v-btn>
        <v-btn color="success" text :disabled="!valid" @click="save">
          {{ $t("form.save") }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
export default {
  name: "GDialog",
  props: {
    value: Boolean,
    i18n: String,
  },
  data() {
    return {
      valid: true,
    };
  },
  computed: {
    dialog: {
      get() {
        return this.value;
      },
      set(val) {
        this.$emit("input", val);
      },
    },
  },
  watch: {
    value() {
      if (this.$refs.form) this.$refs.form.resetValidation();
    },
  },
  methods: {
    close() {
      this.$emit("close");
      this.dialog = false;
    },
    save() {
      if (this.$refs.form && this.$refs.form.validate()) {
        this.$emit("save");
        this.dialog = false;
      }
    },
  },
};
</script>
